/[gentoo-x86]/eclass/haskell-cabal.eclass
Gentoo

Contents of /eclass/haskell-cabal.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.37 - (hide annotations) (download)
Mon Nov 19 21:27:56 2012 UTC (21 months, 3 weeks ago) by slyfox
Branch: MAIN
Changes since 1.36: +4 -3 lines
Fix error case to be more descriptive. Move 'einfo' lower to avoid empty output.

1 slyfox 1.26 # Copyright 1999-2012 Gentoo Foundation
2 kosmikus 1.1 # Distributed under the terms of the GNU General Public License v2
3 slyfox 1.37 # $Header: /var/cvsroot/gentoo-x86/eclass/haskell-cabal.eclass,v 1.36 2012/11/19 20:35:16 slyfox Exp $
4 vapier 1.25
5     # @ECLASS: haskell-cabal.eclass
6     # @MAINTAINER:
7     # Haskell herd <haskell@gentoo.org>
8     # @AUTHOR:
9     # Original author: Andres Loeh <kosmikus@gentoo.org>
10     # Original author: Duncan Coutts <dcoutts@gentoo.org>
11     # @BLURB: for packages that make use of the Haskell Common Architecture for Building Applications and Libraries (cabal)
12     # @DESCRIPTION:
13 kosmikus 1.1 # Basic instructions:
14     #
15     # Before inheriting the eclass, set CABAL_FEATURES to
16     # reflect the tools and features that the package makes
17     # use of.
18     #
19     # Currently supported features:
20     # haddock -- for documentation generation
21 kolmodin 1.21 # hscolour -- generation of colourised sources
22 slyfox 1.35 # hoogle -- generation of documentation search index
23 kosmikus 1.1 # alex -- lexer/scanner generator
24     # happy -- parser generator
25     # c2hs -- C interface generator
26     # cpphs -- C preprocessor clone written in Haskell
27     # profile -- if package supports to build profiling-enabled libraries
28     # bootstrap -- only used for the cabal package itself
29 dcoutts 1.3 # bin -- the package installs binaries
30     # lib -- the package installs libraries
31 kolmodin 1.16 # nocabaldep -- don't add dependency on cabal.
32 slyfox 1.23 # only used for packages that _must_ not pull the dependency
33     # on cabal, but still use this eclass (e.g. haskell-updater).
34 slyfox 1.32 # test-suite -- add support for cabal test-suites (introduced in Cabal-1.8)
35 kosmikus 1.1
36 dcoutts 1.11 inherit ghc-package multilib
37 kosmikus 1.1
38 slyfox 1.24 # @ECLASS-VARIABLE: CABAL_EXTRA_CONFIGURE_FLAGS
39     # @DESCRIPTION:
40     # User-specified additional parameters passed to 'setup configure'.
41     # example: /etc/make.conf: CABAL_EXTRA_CONFIGURE_FLAGS=--enable-shared
42     : ${CABAL_EXTRA_CONFIGURE_FLAGS:=}
43    
44 slyfox 1.27 # @ECLASS-VARIABLE: CABAL_EXTRA_BUILD_FLAGS
45     # @DESCRIPTION:
46     # User-specified additional parameters passed to 'setup build'.
47     # example: /etc/make.conf: CABAL_EXTRA_BUILD_FLAGS=-v
48     : ${CABAL_EXTRA_BUILD_FLAGS:=}
49    
50 slyfox 1.24 # @ECLASS-VARIABLE: GHC_BOOTSTRAP_FLAGS
51     # @DESCRIPTION:
52     # User-specified additional parameters for ghc when building
53     # _only_ 'setup' binary bootstrap.
54     # example: /etc/make.conf: GHC_BOOTSTRAP_FLAGS=-dynamic to make
55     # linking 'setup' faster.
56     : ${GHC_BOOTSTRAP_FLAGS:=}
57    
58 slyfox 1.36 # @ECLASS-VARIABLE: CABAL_DEBUG_LOOSENING
59     # @DESCRIPTION:
60     # Show debug output for 'cabal_chdeps' function if set.
61     # Needs working 'diff'.
62     : ${CABAL_DEBUG_LOOSENING:=}
63    
64 kolmodin 1.19 HASKELL_CABAL_EXPF="pkg_setup src_compile src_test src_install"
65    
66     case "${EAPI:-0}" in
67 axs 1.34 2|3|4|5) HASKELL_CABAL_EXPF+=" src_configure" ;;
68 kolmodin 1.19 *) ;;
69     esac
70    
71     EXPORT_FUNCTIONS ${HASKELL_CABAL_EXPF}
72 kosmikus 1.1
73     for feature in ${CABAL_FEATURES}; do
74     case ${feature} in
75 kolmodin 1.16 haddock) CABAL_USE_HADDOCK=yes;;
76 kolmodin 1.21 hscolour) CABAL_USE_HSCOLOUR=yes;;
77 slyfox 1.26 hoogle) CABAL_USE_HOOGLE=yes;;
78 kolmodin 1.16 alex) CABAL_USE_ALEX=yes;;
79     happy) CABAL_USE_HAPPY=yes;;
80     c2hs) CABAL_USE_C2HS=yes;;
81     cpphs) CABAL_USE_CPPHS=yes;;
82     profile) CABAL_USE_PROFILE=yes;;
83     bootstrap) CABAL_BOOTSTRAP=yes;;
84     bin) CABAL_HAS_BINARIES=yes;;
85     lib) CABAL_HAS_LIBRARIES=yes;;
86     nocabaldep) CABAL_FROM_GHC=yes;;
87 slyfox 1.32 test-suite) CABAL_TEST_SUITE=yes;;
88 dcoutts 1.3 *) CABAL_UNKNOWN="${CABAL_UNKNOWN} ${feature}";;
89 kosmikus 1.1 esac
90     done
91    
92     if [[ -n "${CABAL_USE_HADDOCK}" ]]; then
93     IUSE="${IUSE} doc"
94 slyfox 1.28 # don't require depend on itself to build docs.
95     # ebuild bootstraps docs from just built binary
96     [[ ${CATEGORY}/${PN} = "dev-haskell/haddock" ]] || DEPEND="${DEPEND} doc? ( dev-haskell/haddock )"
97 kosmikus 1.1 fi
98    
99 kolmodin 1.21 if [[ -n "${CABAL_USE_HSCOLOUR}" ]]; then
100     IUSE="${IUSE} hscolour"
101     DEPEND="${DEPEND} hscolour? ( dev-haskell/hscolour )"
102     fi
103    
104 kosmikus 1.1 if [[ -n "${CABAL_USE_ALEX}" ]]; then
105     DEPEND="${DEPEND} dev-haskell/alex"
106     fi
107    
108     if [[ -n "${CABAL_USE_HAPPY}" ]]; then
109     DEPEND="${DEPEND} dev-haskell/happy"
110     fi
111    
112     if [[ -n "${CABAL_USE_C2HS}" ]]; then
113     DEPEND="${DEPEND} dev-haskell/c2hs"
114     fi
115    
116     if [[ -n "${CABAL_USE_CPPHS}" ]]; then
117     DEPEND="${DEPEND} dev-haskell/cpphs"
118     fi
119    
120     if [[ -n "${CABAL_USE_PROFILE}" ]]; then
121     IUSE="${IUSE} profile"
122     fi
123    
124 slyfox 1.32 if [[ -n "${CABAL_TEST_SUITE}" ]]; then
125     IUSE="${IUSE} test"
126     fi
127    
128 kosmikus 1.1 # We always use a standalone version of Cabal, rather than the one that comes
129     # with GHC. But of course we can't depend on cabal when building cabal itself.
130 dcoutts 1.14 if [[ -z ${CABAL_MIN_VERSION} ]]; then
131     CABAL_MIN_VERSION=1.1.4
132     fi
133 kolmodin 1.16 if [[ -z "${CABAL_BOOTSTRAP}" && -z "${CABAL_FROM_GHC}" ]]; then
134 dcoutts 1.11 DEPEND="${DEPEND} >=dev-haskell/cabal-${CABAL_MIN_VERSION}"
135 kosmikus 1.1 fi
136    
137 dcoutts 1.3 # Libraries require GHC to be installed.
138     if [[ -n "${CABAL_HAS_LIBRARIES}" ]]; then
139 dcoutts 1.11 RDEPEND="${RDEPEND} dev-lang/ghc"
140 dcoutts 1.3 fi
141 kosmikus 1.1
142 dcoutts 1.14 # returns the version of cabal currently in use
143     _CABAL_VERSION_CACHE=""
144     cabal-version() {
145     if [[ -z "${_CABAL_VERSION_CACHE}" ]]; then
146     if [[ "${CABAL_BOOTSTRAP}" ]]; then
147     # We're bootstrapping cabal, so the cabal version is the version
148     # of this package itself.
149     _CABAL_VERSION_CACHE="${PV}"
150 kolmodin 1.17 elif [[ "${CABAL_FROM_GHC}" ]]; then
151 slyfox 1.24 local cabal_package=$(echo "$(ghc-libdir)"/Cabal-*)
152     # /path/to/ghc/Cabal-${VER} -> ${VER}
153     _CABAL_VERSION_CACHE="${cabal_package/*Cabal-/}"
154 dcoutts 1.14 else
155     # We ask portage, not ghc, so that we only pick up
156     # portage-installed cabal versions.
157     _CABAL_VERSION_CACHE="$(ghc-extractportageversion dev-haskell/cabal)"
158     fi
159     fi
160     echo "${_CABAL_VERSION_CACHE}"
161     }
162    
163 kosmikus 1.1 cabal-bootstrap() {
164     local setupmodule
165 dcoutts 1.14 local cabalpackage
166 kosmikus 1.1 if [[ -f "${S}/Setup.lhs" ]]; then
167     setupmodule="${S}/Setup.lhs"
168 slyfox 1.29 elif [[ -f "${S}/Setup.hs" ]]; then
169     setupmodule="${S}/Setup.hs"
170 kosmikus 1.1 else
171 slyfox 1.29 die "No Setup.lhs or Setup.hs found"
172 kosmikus 1.1 fi
173    
174 slyfox 1.31 if [[ -z "${CABAL_BOOTSTRAP}" && -z "${CABAL_FROM_GHC}" ]] && ! ghc-sanecabal "${CABAL_MIN_VERSION}"; then
175     eerror "The package dev-haskell/cabal is not correctly installed for"
176     eerror "the currently active version of ghc ($(ghc-version)). Please"
177     eerror "run haskell-updater or re-build dev-haskell/cabal."
178     die "cabal is not correctly installed"
179     fi
180    
181 kosmikus 1.1 # We build the setup program using the latest version of
182     # cabal that we have installed
183 slyfox 1.29 cabalpackage=Cabal-$(cabal-version)
184 dcoutts 1.14 einfo "Using cabal-$(cabal-version)."
185 slyfox 1.24
186     make_setup() {
187 slyfox 1.26 set -- -package "${cabalpackage}" --make "${setupmodule}" \
188 slyfox 1.24 ${GHC_BOOTSTRAP_FLAGS} \
189     "$@" \
190     -o setup
191 slyfox 1.27 echo $(ghc-getghc) ${HCFLAGS} "$@"
192 slyfox 1.26 $(ghc-getghc) "$@"
193 slyfox 1.24 }
194     if $(ghc-supports-shared-libraries); then
195 slyfox 1.30 # # some custom build systems might use external libraries,
196     # # for which we don't have shared libs, so keep static fallback
197     # bug #411789, http://hackage.haskell.org/trac/ghc/ticket/5743#comment:3
198 slyfox 1.35 # http://hackage.haskell.org/trac/ghc/ticket/7062
199     # http://hackage.haskell.org/trac/ghc/ticket/3072
200     # ghc does not set RPATH for extralibs, thus we do it ourselves by hands
201     einfo "Prepending $(ghc-libdir) to LD_LIBRARY_PATH"
202     if [[ ${CHOST} != *-darwin* ]]; then
203     LD_LIBRARY_PATH="$(ghc-libdir)${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
204     export LD_LIBRARY_PATH
205     else
206     DYLD_LIBRARY_PATH="$(ghc-libdir)${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
207     export DYLD_LIBRARY_PATH
208     fi
209     { make_setup -dynamic "$@" && ./setup --help >/dev/null; } ||
210 slyfox 1.30 make_setup "$@" || die "compiling ${setupmodule} failed"
211 slyfox 1.24 else
212     make_setup "$@" || die "compiling ${setupmodule} failed"
213     fi
214 kosmikus 1.1 }
215    
216 dcoutts 1.14 cabal-mksetup() {
217     local setupdir
218    
219     if [[ -n $1 ]]; then
220     setupdir=$1
221     else
222     setupdir=${S}
223     fi
224    
225     rm -f "${setupdir}"/Setup.{lhs,hs}
226    
227     echo 'import Distribution.Simple; main = defaultMainWithHooks defaultUserHooks' \
228 slyfox 1.29 > $setupdir/Setup.hs || die "failed to create default Setup.hs"
229 dcoutts 1.14 }
230    
231 kolmodin 1.21 cabal-hscolour() {
232 slyfox 1.26 set -- hscolour "$@"
233     echo ./setup "$@"
234     ./setup "$@" || die "setup hscolour failed"
235 kolmodin 1.21 }
236    
237 kosmikus 1.1 cabal-haddock() {
238 slyfox 1.26 set -- haddock "$@"
239     echo ./setup "$@"
240     ./setup "$@" || die "setup haddock failed"
241 kosmikus 1.1 }
242    
243 kolmodin 1.21 cabal-hscolour-haddock() {
244     # --hyperlink-source implies calling 'setup hscolour'
245 slyfox 1.26 set -- haddock --hyperlink-source
246     echo ./setup "$@"
247     ./setup "$@" --hyperlink-source || die "setup haddock --hyperlink-source failed"
248 kolmodin 1.21 }
249    
250 kosmikus 1.1 cabal-configure() {
251 slyfox 1.23 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
252    
253 dcoutts 1.14 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
254 slyfox 1.23 cabalconf="${cabalconf} --with-haddock=${EPREFIX}/usr/bin/haddock"
255 dcoutts 1.14 fi
256 kosmikus 1.1 if [[ -n "${CABAL_USE_PROFILE}" ]] && use profile; then
257 dcoutts 1.2 cabalconf="${cabalconf} --enable-library-profiling"
258 kosmikus 1.1 fi
259 slyfox 1.23 if [[ -n "${CABAL_USE_ALEX}" ]]; then
260     cabalconf="${cabalconf} --with-alex=${EPREFIX}/usr/bin/alex"
261     fi
262    
263     if [[ -n "${CABAL_USE_HAPPY}" ]]; then
264     cabalconf="${cabalconf} --with-happy=${EPREFIX}/usr/bin/happy"
265     fi
266    
267     if [[ -n "${CABAL_USE_C2HS}" ]]; then
268     cabalconf="${cabalconf} --with-c2hs=${EPREFIX}/usr/bin/c2hs"
269     fi
270     if [[ -n "${CABAL_USE_CPPHS}" ]]; then
271     cabalconf="${cabalconf} --with-cpphs=${EPREFIX}/usr/bin/cpphs"
272     fi
273 slyfox 1.32 if [[ -n "${CABAL_TEST_SUITE}" ]]; then
274     cabalconf="${cabalconf} $(use_enable test tests)"
275     fi
276 slyfox 1.23
277 slyfox 1.27 local option
278     for option in ${HCFLAGS}
279     do
280     cabalconf+=" --ghc-option=$option"
281     done
282    
283 dcoutts 1.6 # Building GHCi libs on ppc64 causes "TOC overflow".
284     if use ppc64; then
285 dcoutts 1.5 cabalconf="${cabalconf} --disable-library-for-ghci"
286     fi
287 kosmikus 1.1
288 slyfox 1.24 # currently cabal does not respect CFLAGS and LDFLAGS on it's own (bug #333217)
289     # so translate LDFLAGS to ghc parameters (without filtering)
290     local flag
291     for flag in $LDFLAGS; do cabalconf="${cabalconf} --ghc-option=-optl$flag"; done
292    
293 slyfox 1.29 # disable executable stripping for the executables, as portage will
294     # strip by itself, and pre-stripping gives a QA warning.
295     # cabal versions previous to 1.4 does not strip executables, and does
296     # not accept the flag.
297     # this fixes numerous bugs, amongst them;
298     # bug #251881, bug #251882, bug #251884, bug #251886, bug #299494
299     cabalconf="${cabalconf} --disable-executable-stripping"
300    
301     cabalconf="${cabalconf} --docdir=${EPREFIX}/usr/share/doc/${PF}"
302     # As of Cabal 1.2, configure is quite quiet. For diagnostic purposes
303     # it's better if the configure chatter is in the build logs:
304     cabalconf="${cabalconf} --verbose"
305 dcoutts 1.11
306 slyfox 1.24 # We build shared version of our Cabal where ghc ships it's shared
307     # version of it. We will link ./setup as dynamic binary againt Cabal later.
308     [[ ${CATEGORY}/${PN} == "dev-haskell/cabal" ]] && \
309     $(ghc-supports-shared-libraries) && \
310     cabalconf="${cabalconf} --enable-shared"
311    
312 slyfox 1.35 if $(ghc-supports-shared-libraries); then
313     # maybe a bit lower
314     if version_is_at_least "7.7.20121114" "$(ghc-version)"; then
315     cabalconf="${cabalconf} --enable-shared"
316     fi
317     fi
318    
319 slyfox 1.26 set -- configure \
320 slyfox 1.23 --ghc --prefix="${EPREFIX}"/usr \
321 kosmikus 1.1 --with-compiler="$(ghc-getghc)" \
322     --with-hc-pkg="$(ghc-getghcpkg)" \
323 slyfox 1.23 --prefix="${EPREFIX}"/usr \
324     --libdir="${EPREFIX}"/usr/$(get_libdir) \
325 dcoutts 1.11 --libsubdir=${P}/ghc-$(ghc-version) \
326 slyfox 1.23 --datadir="${EPREFIX}"/usr/share/ \
327 dcoutts 1.11 --datasubdir=${P}/ghc-$(ghc-version) \
328 kosmikus 1.1 ${cabalconf} \
329 kosmikus 1.8 ${CABAL_CONFIGURE_FLAGS} \
330 slyfox 1.24 ${CABAL_EXTRA_CONFIGURE_FLAGS} \
331 slyfox 1.26 "$@"
332     echo ./setup "$@"
333     ./setup "$@" || die "setup configure failed"
334 kosmikus 1.1 }
335    
336     cabal-build() {
337 dcoutts 1.14 unset LANG LC_ALL LC_MESSAGES
338 slyfox 1.27 set -- build ${CABAL_EXTRA_BUILD_FLAGS} "$@"
339 slyfox 1.26 echo ./setup "$@"
340     ./setup "$@" \
341 kosmikus 1.1 || die "setup build failed"
342     }
343    
344     cabal-copy() {
345 slyfox 1.23 has "${EAPI:-0}" 0 1 2 && ! use prefix && ED=${D}
346    
347 slyfox 1.26 set -- copy --destdir="${D}" "$@"
348     echo ./setup "$@"
349     ./setup "$@" || die "setup copy failed"
350 kosmikus 1.1
351     # cabal is a bit eager about creating dirs,
352     # so remove them if they are empty
353 slyfox 1.23 rmdir "${ED}/usr/bin" 2> /dev/null
354 kosmikus 1.1 }
355    
356     cabal-pkg() {
357 kosmikus 1.9 # This does not actually register since we're using true instead
358 slyfox 1.29 # of ghc-pkg. So it just leaves the .conf file and we can
359 kosmikus 1.1 # register that ourselves (if it exists).
360 dcoutts 1.2
361 dcoutts 1.4 if [[ -n ${CABAL_HAS_LIBRARIES} ]]; then
362 slyfox 1.29 # Newer cabal can generate a package conf for us:
363     ./setup register --gen-pkg-config="${T}/${P}.conf"
364     ghc-setup-pkg "${T}/${P}.conf"
365     ghc-install-pkg
366 kosmikus 1.1 fi
367     }
368    
369 kolmodin 1.13 # Some cabal libs are bundled along with some versions of ghc
370     # eg filepath-1.0 comes with ghc-6.6.1
371     # by putting CABAL_CORE_LIB_GHC_PV="6.6.1" in an ebuild we are declaring that
372     # when building with this version of ghc, the ebuild is a dummy that is it will
373     # install no files since the package is already included with ghc.
374     # However portage still records the dependency and we can upgrade the package
375     # to a later one that's not included with ghc.
376     # You can also put a space separated list, eg CABAL_CORE_LIB_GHC_PV="6.6 6.6.1".
377     cabal-is-dummy-lib() {
378     for version in ${CABAL_CORE_LIB_GHC_PV[*]}; do
379 slyfox 1.33 [[ "$(ghc-version)" == ${version} ]] && return 0
380 kolmodin 1.13 done
381     return 1
382     }
383    
384 kosmikus 1.1 # exported function: check if cabal is correctly installed for
385     # the currently active ghc (we cannot guarantee this with portage)
386     haskell-cabal_pkg_setup() {
387 dcoutts 1.4 if [[ -z "${CABAL_HAS_BINARIES}" ]] && [[ -z "${CABAL_HAS_LIBRARIES}" ]]; then
388 slyfox 1.29 eqawarn "QA Notice: Neither bin nor lib are in CABAL_FEATURES."
389 dcoutts 1.4 fi
390 dcoutts 1.3 if [[ -n "${CABAL_UNKNOWN}" ]]; then
391 slyfox 1.29 eqawarn "QA Notice: Unknown entry in CABAL_FEATURES: ${CABAL_UNKNOWN}"
392 dcoutts 1.3 fi
393 kolmodin 1.13 if cabal-is-dummy-lib; then
394     einfo "${P} is included in ghc-${CABAL_CORE_LIB_GHC_PV}, nothing to install."
395     fi
396 kosmikus 1.1 }
397    
398 kolmodin 1.19 haskell-cabal_src_configure() {
399 slyfox 1.29 cabal-is-dummy-lib && return
400    
401     pushd "${S}" > /dev/null
402 kolmodin 1.19
403 slyfox 1.29 cabal-bootstrap
404 slyfox 1.22
405 slyfox 1.29 cabal-configure "$@"
406 kolmodin 1.19
407 slyfox 1.29 popd > /dev/null
408 kolmodin 1.19 }
409    
410     # exported function: nice alias
411     cabal_src_configure() {
412     haskell-cabal_src_configure "$@"
413     }
414    
415 kosmikus 1.1 # exported function: cabal-style bootstrap configure and compile
416     cabal_src_compile() {
417 slyfox 1.24 # it's a common mistake when one bumps ebuild to EAPI="2" (and upper)
418     # and forgets to separate src_compile() to src_configure()/src_compile().
419     # Such error leads to default src_configure and we lose all passed flags.
420     if ! has "${EAPI:-0}" 0 1; then
421     local passed_flag
422     for passed_flag in "$@"; do
423     [[ ${passed_flag} == --flags=* ]] && \
424 slyfox 1.29 eqawarn "QA Notice: Cabal option '${passed_flag}' has effect only in src_configure()"
425 slyfox 1.24 done
426     fi
427    
428 slyfox 1.29 cabal-is-dummy-lib && return
429    
430     has src_configure ${HASKELL_CABAL_EXPF} || haskell-cabal_src_configure "$@"
431     cabal-build
432 kosmikus 1.1
433 slyfox 1.29 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
434     if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
435     # hscolour and haddock
436     cabal-hscolour-haddock
437 kolmodin 1.21 else
438 slyfox 1.29 # just haddock
439     cabal-haddock
440     fi
441     else
442     if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
443     # just hscolour
444     cabal-hscolour
445 kolmodin 1.13 fi
446 kosmikus 1.1 fi
447     }
448 kolmodin 1.16
449 kosmikus 1.1 haskell-cabal_src_compile() {
450 kolmodin 1.19 pushd "${S}" > /dev/null
451    
452     cabal_src_compile "$@"
453    
454     popd > /dev/null
455     }
456    
457     haskell-cabal_src_test() {
458     pushd "${S}" > /dev/null
459    
460 kolmodin 1.20 if cabal-is-dummy-lib; then
461     einfo ">>> No tests for dummy library: ${CATEGORY}/${PF}"
462     else
463     einfo ">>> Test phase [cabal test]: ${CATEGORY}/${PF}"
464 slyfox 1.26 set -- test "$@"
465     echo ./setup "$@"
466     ./setup "$@" || die "cabal test failed"
467 kolmodin 1.20 fi
468 kolmodin 1.19
469     popd > /dev/null
470 kosmikus 1.1 }
471    
472     # exported function: cabal-style copy and register
473     cabal_src_install() {
474 slyfox 1.23 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
475    
476 slyfox 1.29 if ! cabal-is-dummy-lib; then
477 kolmodin 1.13 cabal-copy
478     cabal-pkg
479 slyfox 1.29 fi
480 kosmikus 1.1
481 slyfox 1.29 # create a dummy local package conf file for haskell-updater
482     # if it does not exist (dummy libraries and binaries w/o libraries)
483     local ghc_confdir_with_prefix="$(ghc-confdir)"
484     # remove EPREFIX
485     dodir ${ghc_confdir_with_prefix#${EPREFIX}}
486     local conf_file="${D}/$(ghc-confdir)/$(ghc-localpkgconf)"
487     [[ -e $conf_file ]] || echo '[]' > "$conf_file" || die
488 slyfox 1.33
489     # make sure installed packages do not destroy ghc's
490     # bundled packages
491     local initial_pkg_db=${ROOT}/$(ghc-libdir)/package.conf.d.initial
492     if [[ -e ${initial_pkg_db} ]]; then
493     local checked_pkg
494     for checked_pkg in $(ghc-listpkg "${conf_file}")
495     do
496     local initial_pkg
497     for initial_pkg in $(ghc-listpkg "${initial_pkg_db}"); do
498     if [[ ${checked_pkg} = ${initial_pkg} ]]; then
499     eerror "Package ${checked_pkg} is shipped with $(ghc-version)."
500     eerror "Ebuild author forgot CABAL_CORE_LIB_GHC_PV entry."
501     eerror "Found in ${initial_pkg_db}."
502     die
503     fi
504     done
505     done
506     fi
507 kosmikus 1.1 }
508 kolmodin 1.19
509 kosmikus 1.1 haskell-cabal_src_install() {
510 kolmodin 1.19 pushd "${S}" > /dev/null
511    
512 kosmikus 1.1 cabal_src_install
513 kolmodin 1.19
514     popd > /dev/null
515 kosmikus 1.1 }
516    
517 kolmodin 1.19 # ebuild.sh:use_enable() taken as base
518     #
519     # Usage examples:
520     #
521     # CABAL_CONFIGURE_FLAGS=$(cabal_flag gui)
522     # leads to "--flags=gui" or "--flags=-gui" (useflag 'gui')
523     #
524     # CABAL_CONFIGURE_FLAGS=$(cabal_flag gtk gui)
525     # also leads to "--flags=gui" or " --flags=-gui" (useflag 'gtk')
526     #
527     cabal_flag() {
528     if [[ -z "$1" ]]; then
529     echo "!!! cabal_flag() called without a parameter." >&2
530     echo "!!! cabal_flag() <USEFLAG> [<cabal_flagname>]" >&2
531     return 1
532     fi
533    
534     local UWORD=${2:-$1}
535    
536     if use "$1"; then
537     echo "--flags=${UWORD}"
538     else
539     echo "--flags=-${UWORD}"
540     fi
541    
542     return 0
543     }
544 slyfox 1.36
545     # @FUNCTION: cabal_chdeps
546     # @DESCRIPTION:
547     # Allows easier patching of $CABAL_FILE (${S}/${PN}.cabal by default)
548     # depends
549     #
550     # Accepts argument list as pairs of substitutions: <from-string> <to-string>...
551     #
552     # Dies on error.
553     #
554     # Usage examples:
555     #
556     # src_prepare() {
557     # cabal_chdeps \
558     # 'base >= 4.2 && < 4.6' 'base >= 4.2 && < 4.7' \
559     # 'containers ==0.4.*' 'containers >= 0.4 && < 0.6'
560     #}
561     # or
562     # src_prepare() {
563     # CABAL_FILE=${S}/${MY_PN}.cabal cabal_chdeps \
564     # 'base >= 4.2 && < 4.6' 'base >= 4.2 && < 4.7'
565     # CABAL_FILE=${S}/${MY_PN}-tools.cabal cabal_chdeps \
566     # 'base == 3.*' 'base >= 4.2 && < 4.7'
567     #}
568     #
569     cabal_chdeps() {
570     local cf=${CABAL_FILE:-${S}/${PN}.cabal}
571     local from_ss # ss - substring
572     local to_ss
573     local orig_c # c - contents
574     local new_c
575    
576     [[ -f $cf ]] || die "cabal file '$cf' does not exist"
577    
578     orig_c=$(< "$cf")
579    
580     while :; do
581     from_pat=$1
582     to_str=$2
583    
584     [[ -n ${from_pat} ]] || break
585     [[ -n ${to_str} ]] || die "'${from_str}' does not have 'to' part"
586    
587 slyfox 1.37 einfo "CHDEP: '${from_pat}' -> '${to_str}'"
588    
589 slyfox 1.36 # escape pattern-like symbols
590     from_pat=${from_pat//\*/\\*}
591     from_pat=${from_pat//\[/\\[}
592    
593     new_c=${orig_c//${from_pat}/${to_str}}
594    
595     if [[ -n $CABAL_DEBUG_LOOSENING ]]; then
596     echo "${orig_c}" >"${T}/${cf}".pre
597     echo "${new_c}" >"${T}/${cf}".post
598     diff -u "${T}/${cf}".{pre,post}
599     fi
600    
601 slyfox 1.37 [[ "${orig_c}" == "${new_c}" ]] && die "no trigger for '${from_pat}'"
602 slyfox 1.36 orig_c=${new_c}
603     shift
604     shift
605     done
606    
607     echo "${new_c}" > "$cf" ||
608     die "failed to update"
609     }

  ViewVC Help
Powered by ViewVC 1.1.20